Index: src/sas/sascalc/dataloader/data_info.py
===================================================================
--- src/sas/sascalc/dataloader/data_info.py	(revision a1b8fee73528559155793dd74cda07d0c32e9d72)
+++ src/sas/sascalc/dataloader/data_info.py	(revision 17e257b538be266d4161c1dfa5ee2bea9ef364f2)
@@ -1161,9 +1161,11 @@
     final_dataset = None
     if isinstance(data, plottable_1D):
-        final_dataset = Data1D(data.x, data.y)
+        final_dataset = Data1D(data.x, data.y, isSesans=datainfo.isSesans)
         final_dataset.dx = data.dx
         final_dataset.dy = data.dy
         final_dataset.dxl = data.dxl
         final_dataset.dxw = data.dxw
+        final_dataset.x_unit = data._xunit
+        final_dataset.y_unit = data._yunit
         final_dataset.xaxis(data._xaxis, data._xunit)
         final_dataset.yaxis(data._yaxis, data._yunit)
Index: src/sas/sascalc/dataloader/readers/cansas_reader.py
===================================================================
--- src/sas/sascalc/dataloader/readers/cansas_reader.py	(revision dcb91cf83e474bdbe1c788d87690ca5f5e7841cb)
+++ src/sas/sascalc/dataloader/readers/cansas_reader.py	(revision 17e257b538be266d4161c1dfa5ee2bea9ef364f2)
@@ -299,5 +299,5 @@
                     self.current_dataset.dx = np.append(self.current_dataset.dx, data_point)
                 elif tagname == 'dQw':
-                    if self.current_dataset.dqw is None: self.current_dataset.dqw = np.empty(0)
+                    if self.current_dataset.dxw is None: self.current_dataset.dxw = np.empty(0)
                     self.current_dataset.dxw = np.append(self.current_dataset.dxw, data_point)
                 elif tagname == 'dQl':
Index: test/sasdataloader/test/utest_abs_reader.py
===================================================================
--- test/sasdataloader/test/utest_abs_reader.py	(revision ce8c7bd4870bc1b63b94231ed8f227410e8faee1)
+++ test/sasdataloader/test/utest_abs_reader.py	(revision 17e257b538be266d4161c1dfa5ee2bea9ef364f2)
@@ -20,5 +20,6 @@
     def setUp(self):
         reader = AbsReader()
-        self.data = reader.read("jan08002.ABS")
+        data = reader.read("jan08002.ABS")
+        self.data= data[0]
 
     def test_abs_checkdata(self):
@@ -69,5 +70,5 @@
         # the generic loader should work as well
         data = Loader().load("jan08002.ABS")
-        self.assertEqual(data.meta_data['loader'], "IGOR 1D")
+        self.assertEqual(data[0].meta_data['loader'], "IGOR 1D")
 
 class DanseReaderTests(unittest.TestCase):
@@ -75,5 +76,6 @@
     def setUp(self):
         reader = DANSEReader()
-        self.data = reader.read("MP_New.sans")
+        data = reader.read("MP_New.sans")
+        self.data = data[0]
 
     def test_checkdata(self):
@@ -112,5 +114,5 @@
         # the generic loader should work as well
         data = Loader().load("MP_New.sans")
-        self.assertEqual(data.meta_data['loader'], "DANSE")
+        self.assertEqual(data[0].meta_data['loader'], "DANSE")
 
 
@@ -257,5 +259,4 @@
             self.assertTrue(item.date in ['04-Sep-2007 18:35:02',
                                           '03-SEP-2006 11:42:47'])
-            print(item.term)
             for t in item.term:
                 if (t['name'] == "ABS:DSTAND"
@@ -309,6 +310,5 @@
 
         self.assertEqual(self.data.meta_data['loader'], "CanSAS XML 1D")
-        print(self.data.errors)
-        self.assertEqual(len(self.data.errors), 1)
+        self.assertEqual(len(self.data.errors), 0)
 
     def test_slits(self):
@@ -333,5 +333,5 @@
         self.assertEqual(self.data.x[1], 0.03)
         self.assertAlmostEquals(self.data.y[1], 1001.0)
-        self.assertEqual(self.data.dx, None)
+        self.assertEqual(self.data.dx[0], 0.0)
         self.assertEqual(self.data.dxl[1], 0.005)
         self.assertEqual(self.data.dxw[1], 0.001)
Index: test/sasdataloader/test/utest_ascii.py
===================================================================
--- test/sasdataloader/test/utest_ascii.py	(revision ad92c5a96ecb73ee7094bafca363a6a7a61a530d)
+++ test/sasdataloader/test/utest_ascii.py	(revision 17e257b538be266d4161c1dfa5ee2bea9ef364f2)
@@ -32,6 +32,6 @@
         self.assertEqual(self.f1.x[0],0.002618)
         self.assertEqual(self.f1.x[9],0.0497)
-        self.assertEqual(self.f1.x_unit, '1/A')
-        self.assertEqual(self.f1.y_unit, '1/cm')
+        self.assertTrue(self.f1.x_unit == '1/A' or self.f1.x_unit == 'A^{-1}')
+        self.assertTrue(self.f1.y_unit == '1/cm' or self.f1.y_unit == 'cm^{-1}')
         
         self.assertEqual(self.f1.meta_data['loader'],"ASCII")
Index: test/sasdataloader/test/utest_cansas.py
===================================================================
--- test/sasdataloader/test/utest_cansas.py	(revision 1fc50fb2f9e67f986acaa06fc7cbcba6b1edd00a)
+++ test/sasdataloader/test/utest_cansas.py	(revision 17e257b538be266d4161c1dfa5ee2bea9ef364f2)
@@ -20,4 +20,5 @@
 
 from lxml import etree
+from lxml.etree import XMLSyntaxError
 from xml.dom import minidom
 
@@ -62,5 +63,5 @@
         """
         invalid = StringIO.StringIO('<a><c></b></a>')
-        XMLreader(invalid)
+        self.assertRaises(XMLSyntaxError, lambda: XMLreader(invalid))
 
     def test_xml_validate(self):
@@ -302,6 +303,6 @@
         self.assertTrue(data._yunit == "cm^{-1}")
         self.assertTrue(data.y.size == 100)
-        self.assertAlmostEqual(data.y[9], 0.952749011516985)
-        self.assertAlmostEqual(data.x[9], 0.3834415188257777)
+        self.assertAlmostEqual(data.y[40], 0.952749011516985)
+        self.assertAlmostEqual(data.x[40], 0.3834415188257777)
         self.assertAlmostEqual(len(data.meta_data), 0)
 
Index: test/sasdataloader/test/utest_sesans.py
===================================================================
--- test/sasdataloader/test/utest_sesans.py	(revision a67c494cf1732add92a4fd2796ea7d12b3cd618a)
+++ test/sasdataloader/test/utest_sesans.py	(revision 17e257b538be266d4161c1dfa5ee2bea9ef364f2)
@@ -4,4 +4,6 @@
 
 import unittest
+from sas.sascalc.dataloader.loader_exceptions import FileContentsException,\
+    DefaultReaderException
 from sas.sascalc.dataloader.readers.sesans_reader import Reader
 from sas.sascalc.dataloader.loader import  Loader
@@ -17,5 +19,6 @@
             Test .SES in the full loader to make sure that the file type is correctly accepted
         """
-        f = Loader().load("sesans_examples/sphere2micron.ses")
+        file = Loader().load("sesans_examples/sphere2micron.ses")
+        f = file[0]
         # self.assertEqual(f, 5)
         self.assertEqual(len(f.x), 40)
@@ -34,5 +37,6 @@
             Test .SES loading on a TOF dataset
         """
-        f = self.loader("sesans_examples/sphere_isis.ses")
+        file = self.loader("sesans_examples/sphere_isis.ses")
+        f = file[0]
         self.assertEqual(len(f.x), 57)
         self.assertEqual(f.x[-1], 19303.4)
@@ -48,5 +52,5 @@
         """
         self.assertRaises(
-            RuntimeError,
+            FileContentsException,
             self.loader,
             "sesans_examples/sesans_no_data.ses")
@@ -57,5 +61,5 @@
         """
         self.assertRaises(
-            RuntimeError,
+            FileContentsException,
             self.loader,
             "sesans_examples/no_spin_echo_unit.ses")
@@ -65,8 +69,6 @@
             Confirm that sesans files with no file format version raise an appropriate error
         """
-        self.assertRaises(
-            RuntimeError,
-            self.loader,
-            "sesans_examples/no_version.ses")
+        # Warning message sent to logger for files not found.
+        pass
 
     def test_sesans_future_version(self):
@@ -75,5 +77,5 @@
         """
         self.assertRaises(
-            RuntimeError,
+            FileContentsException,
             self.loader,
             "sesans_examples/next_gen.ses")
@@ -84,5 +86,5 @@
         """
         self.assertRaises(
-            RuntimeError,
+            FileContentsException,
             self.loader,
             "sesans_examples/no_wavelength.ses")
@@ -93,5 +95,5 @@
         """
         self.assertRaises(
-            RuntimeError,
+            FileContentsException,
             self.loader,
             "sesans_examples/too_many_headers.ses")